#include "controller.h"
#include <iostream>
#include <string>
#include <fstream>
#include <bitset>
#include <sstream>
#include <list>
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Multiline_Output.H>
#include <FL/Fl_Button.H>


using namespace std;


Controller::Controller(int w,int h,const char * name=0):Fl_Window(w,h,name)
{
	begin();
	mainWindow =new Fl_Window(400,200);
	outputWin =new Fl_Multiline_Output(65,20,275,120,"status");
	but1=new Fl_Button(138,155,10,10,"1");
	but2=new Fl_Button(163,155,10,10,"2");
	but3=new Fl_Button(188,155,10,10,"3");
	but4=new Fl_Button(213,155,10,10,"4");
	but5=new Fl_Button(238,155,10,10,"5");
	but6=new Fl_Button(263,155,10,10,"6");
	defaults_but= new Fl_Round_Button(18,149, 20,20);
	end();

	mainWindow->callback(window_cb, this); //main window callback for exit button
	defaults_but->label("reset");
	defaults_but->callback(defaults_cb,this);
	but1->callback(button_cb,this);
	but2->callback(button_cb,this);
	but3->callback(button_cb,this);
	but4->callback(button_cb,this);
	but5->callback(button_cb,this);
	but6->callback(button_cb,this);
	mainWindow->color(170);
	mainWindow->label("Icewinconfig");
	outputWin->color(220);
	outputWin->value("");
	
	mainWindow->show();
	
	ifstream infile;
	infile.open("preferences");
	
	if(!infile)
		{//trap non-existant preferences file
			fl_alert("Icewin preferences file not found");
			exit(1);
		}
	
	string hold="";
	
	string show_task_bar = "ShowTaskBar";
	string task_bar_at_top = "TaskBarAtTop";
	string task_bar_auto_hide = "TaskBarAutoHide";
	string task_bar_show_show_desktop_button = "TaskBarShowShowDesktopButton";
	string task_bar_show_window_icons = "TaskBarShowWindowIcons";
	string task_bar_double_height = "TaskBarDoubleHeight";
	
	//populate options list
	option_names.push_back(show_task_bar);
	option_names.push_back(task_bar_at_top);
	option_names.push_back(task_bar_auto_hide);
	option_names.push_back(task_bar_show_show_desktop_button);
	option_names.push_back(task_bar_show_window_icons);
	option_names.push_back(task_bar_double_height);
	
	//populate mainlist
	while(!infile.eof())
	{
		getline(infile,hold);
		mainlist.push_back(hold);
	}
	
	infile.close();		
	
	//initialise status
	int i=0; //bitset counter
	list<string>::iterator lsi=option_names.begin();
	for(;lsi!=option_names.end();lsi++)
	{
		
		list<string>::iterator mli=mainlist.begin();
		string searchterm=*lsi;
		for(;mli!=mainlist.end();mli++)
		{
			if((*mli)[0]!='#' && (*mli).find(*lsi)!=string::npos)
			{
				istringstream instream(*mli);
				string temp="";
				instream >> temp;
				char value=temp[temp.length()-1];
				if(value=='1')
					toggles.set(i);
				
				
			}
				
		}
		i++;
	}
	
	
	string header="click button '*' to toggle option '*'\n";
	outputWin->value((header + returnStatus()).c_str());	
	
	
}

void Controller::writeToDisk()
{//save changes back to disk
	
	
	
	ofstream outfile;
	outfile.open("preferences");
	list<string>::iterator lsi=option_names.begin();
	
	int i=0;
	for(;lsi!=option_names.end();lsi++)
	{
		
		list<string>::iterator mli=mainlist.begin();
		string searchterm=*lsi;
		for(;mli!=mainlist.end();mli++)
		{
			if((*mli)[0]!='#' && (*mli).find(*lsi)!=string::npos)
			{
				istringstream instream(*mli);
				string temp="",backend="",word="";
				instream >> temp;
				if(toggles.test(i))
					{
						temp[temp.length()-1]='1';
						
						//now extract backend of option line
						while(instream >> word)
							{
								backend=backend + word + " ";
							}
						temp=temp + " " + backend;
						*mli=temp;
						
					}
				
				else if(!toggles.test(i))
					{
						temp[temp.length()-1]='0';
						while(instream >> word)
							{
								backend=backend + word + " ";
							}
						temp=temp + " " + backend;
						*mli=temp;
						
					}		
					
				
				
			}
				
		}
		i++;
	}
	
	
	list<string>::iterator mli2=mainlist.begin(); //write to file
	for(;mli2!=mainlist.end();mli2++)
		outfile << *mli2 << endl;
	
	outfile.close();
	
	
	
	
}

	
bitset<6>  Controller::returnOptionsStatus()
{
	return toggles;
}
	
void Controller::flipper(int i)
{
	toggles.flip(i);	
}

void Controller::setFolderName(string foldername)
{}//not implemented
	
string Controller::returnStatus()
{
	int count=0;
	
	
	for(count=0;count<6;count ++)
	{// return status of toggles structure as string
		switch(count)
		{
			
			case 0:cat=cat + "1. show taskbar " + "is "; if(toggles.test(count)) cat=cat+" on\n";else cat=cat+" off\n";
				break;
			case 1:cat=cat + "2. taskbar at top " + "is "; if(toggles.test(count)) cat=cat+" on\n";else cat=cat+" off\n";
				break;
			case 2:cat=cat + "3. taskbar auto hide " + "is "; if(toggles.test(count)) cat=cat+" on\n";else cat=cat+" off\n";
				break;
			case 3:cat=cat + "4. show desktop button " + "is "; if(toggles.test(count)) cat=cat+" on\n";else cat=cat+" off\n";
				break;
			case 4:cat=cat + "5. taskbar show window icons " + "is "; if(toggles.test(count)) cat=cat+" on\n";else cat=cat+" off\n";
				break;
			case 5:cat=cat + "6. taskbar double height " + "is "; if(toggles.test(count)) cat=cat+" on\n";else cat=cat+" off\n";
				break;
		}
		
	
	}//end of for loop
	
	
	
	
	return cat;
	
	
}

void Controller::window_cb(Fl_Widget* w, void* userdata) //callback function for main window exit
{
	Controller * Myclass = (Controller *)userdata;
	fl_alert("Restart Icewin from start menu to see your changes");
	Myclass->writeToDisk();
	exit(1);
}

void Controller::button_cb(Fl_Widget * w, void * userdata)
{
	
	
	Controller * Myclass = (Controller *)userdata;
	string header="click button '*' to toggle option '*'\n";
	Myclass->cat="";
	Myclass->outputWin->value("");
	
	
	
	if(w==Myclass->but1) 
		Myclass->flipper(0);
	else if(w==Myclass->but2) 
		Myclass->flipper(1);
	else if(w==Myclass->but3) 
		Myclass->flipper(2);
	else if(w==Myclass->but4) 
		Myclass->flipper(3);
	else if(w==Myclass->but5) 
		Myclass->flipper(4);
	else if(w==Myclass->but6) 
		Myclass->flipper(5);
	

	

	Myclass->cat=Myclass ->returnStatus();
	Myclass->outputWin->value((header + (Myclass->cat)).c_str());
	Myclass->outputWin->redraw();
	
	
}

void Controller::defaults_cb(Fl_Widget * w, void * userdata)
{
	
	//Controller data(400,200,"icewinconfig");
	
	Controller * Myclass = (Controller *)userdata;
	string header="click button '*' to toggle option '*'\n";
	Myclass->cat="";
	Myclass->outputWin->value("");
	
	
	Myclass->toggles.set(0);
	Myclass->toggles.reset(1);
	Myclass->toggles.reset(2);
	Myclass->toggles.set(3);
	Myclass->toggles.set(4);
	Myclass->toggles.reset(5);

	

	Myclass->cat=Myclass ->returnStatus();
	Myclass->outputWin->value((header + (Myclass->cat)).c_str());
	Myclass->outputWin->redraw();
	//Myclass->writeToDisk();
	
}

