#ifndef CONTROLLER_H
#define CONTROLLER_H

#include <fstream>
#include <bitset>
#include <string>
#include <list>
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Multiline_Output.H>
#include <FL/Fl_Round_Button.H>
#include <FL/fl_ask.H>
using namespace std;


class Controller:public Fl_Window
{
	
	private:
		bitset<6> toggles;
		ifstream infile;
		ofstream outfile;
		string foldername;
		list<string> mainlist; //holds option lines from preferences file
		list<string> option_names; //holds list of option names to be processed
		static void window_cb(Fl_Widget* ,void* );//main window callback fn
		static void button_cb(Fl_Widget* ,void*); //button callback fn
		static void defaults_cb(Fl_Widget*,void*);//reset button callback
		string cat;
		
		
	public:
		Controller(int,int,const char *);
		void writeToDisk();
		bitset<6>  returnOptionsStatus();
		void setOptionStatus(int);
		void setFolderName(string);
		void flipper(int); //function to flip bitset
		string returnStatus();
		
};
		



#endif
